Deleted Added
sdiff udiff text old ( 51210 ) new ( 51231 )
full compact
1#!/bin/sh
2# $FreeBSD: head/etc/rc 51210 1999-09-12 18:13:11Z roberto $
3# From: @(#)rc 5.27 (Berkeley) 6/5/91
4
5# System startup script run by init on autoboot
6# or after single-user.
7# Output and error are redirected to console by init,
8# and the console is the controlling terminal.
9
10# Note that almost all the user-configurable behavior is no longer in
11# this file, but rather in /etc/defaults/rc.conf. Please check this file
12# first before contemplating any changes here.
13
14stty status '^T'
15
16# Set shell to ignore SIGINT (2), but not children;
17# shell catches SIGQUIT (3) and returns to single user after fsck.
18trap : 2
19trap : 3 # shouldn't be needed
20
21HOME=/; export HOME
22PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin
23export PATH
24
25# BOOTP diskless boot. We have to run the rc file early in order to
26# retarget various config files.
27#
28if [ -f /etc/rc.diskless1 ]; then
29 dlv=`/sbin/sysctl -n vfs.nfs.diskless_valid 2> /dev/null`
30 if [ ${dlv:=0} != 0 ]; then
31 . /etc/rc.diskless1
32 fi
33fi
34
35# If there is a global system configuration file, suck it in.
36#
37if [ -f /etc/defaults/rc.conf ]; then
38 . /etc/defaults/rc.conf
39elif [ -f /etc/rc.conf ]; then
40 . /etc/rc.conf
41fi
42
43# Configure ccd devices.
44if [ -f /etc/ccd.conf ]; then
45 ccdconfig -C
46fi
47
48if [ "${start_vinum}" = "YES" ]; then
49 vinum start
50elif [ -n "${vinum_drives}" ]; then
51 vinum read ${vinum_drives}
52fi
53
54swapon -a
55
56if [ "$1" = "autoboot" ]; then
57 echo Automatic reboot in progress...
58 fsck -p
59 case $? in
60 0)
61 ;;
62 2)
63 exit 1
64 ;;

--- 14 unchanged lines hidden (view full) ---

79 # interrupt before catcher installed
80 exit 1
81 ;;
82 *)
83 echo "Unknown error in reboot"
84 exit 1
85 ;;
86 esac
87else
88 echo Skipping disk checks ...
89fi
90
91set -T
92trap "echo 'Reboot interrupted'; exit 1" 3
93
94# root normally must be read/write, but if this is a BOOTP NFS
95# diskless boot it does not have to be.
96#
97
98if [ "${root_rw_mount}" != "NO" ]; then
99 mount -u -o rw /
100fi
101
102if [ $? != 0 ]; then
103 echo "Filesystem mount failed, startup aborted"
104 exit 1
105fi
106
107umount -a >/dev/null 2>&1
108
109if [ "${early_nfs_mounts}" != "YES" ]; then
110 mount -a -t nonfs
111else
112 mount -a
113fi
114if [ $? != 0 ]; then
115 echo "Filesystem mount failed, startup aborted"
116 exit 1
117fi
118
119# Run custom disk mounting function here
120#
121
122if [ -n "${diskless_mount}" ]; then
123 if [ -f "${diskless_mount}" ]; then
124 sh ${diskless_mount}
125 fi
126fi
127
128adjkerntz -i
129
130clean_var() {
131 if [ ! -f /var/run/clean_var ]; then
132 rm -rf /var/run/*
133 rm -f /var/spool/lock/*
134 rm -rf /var/spool/uucp/.Temp/*
135 # Keep a copy of the boot messages around
136 dmesg >/var/run/dmesg.boot
137 # And an initial utmp file
138 (cd /var/run && cp /dev/null utmp && chmod 644 utmp; )
139 >/var/run/clean_var
140 fi
141}
142
143if [ -d /var/run -a -d /var/spool/lock -a -d /var/spool/uucp/.Temp ]; then
144 # network_pass1() *may* end up writing stuff to /var - we don't want to
145 # remove it immediately afterwards - *nor* to we want to fail to clean
146 # an nfs-mounted /var.
147 clean_var
148fi
149
150# Add additional swapfile, if configured.
151if [ "${swapfile}" != "NO" -a -w "${swapfile}" -a -b /dev/vn0b ]; then
152 echo "Adding ${swapfile} as additional swap."
153 vnconfig /dev/vn0b ${swapfile} && swapon /dev/vn0b
154fi
155
156# set sysctl variables early as we can
157if [ -f /etc/rc.sysctl ]; then
158 . /etc/rc.sysctl
159fi
160
161# configure serial devices
162if [ -f /etc/rc.serial ]; then
163 . /etc/rc.serial
164fi
165
166# start up PC-card configuration
167if [ -f /etc/rc.pccard ]; then
168 . /etc/rc.pccard
169fi
170
171# start up the initial network configuration.
172if [ -f /etc/rc.network ]; then
173 . /etc/rc.network # We only need to do this once.
174 network_pass1
175fi
176
177echo -n "Mounting NFS file systems"
178mount -a -t nfs
179echo .
180
181# Whack the pty perms back into shape.
182chflags 0 /dev/tty[pqrsPQRS]*
183chmod 666 /dev/tty[pqrsPQRS]*
184chown root:wheel /dev/tty[pqrsPQRS]*
185
186# clean up left-over files
187clean_var # If it hasn't already been done
188rm /var/run/clean_var
189
190#
191# Clearing /tmp at boot-time seems to have a long tradition. It doesn't
192# help in any way for long-living systems, and it might accidentally
193# clobber files you would rather like to have preserved after a crash
194# (if not using mfs /tmp anyway).
195#
196# See also the example of another cleanup policy in /etc/periodic/daily.
197#
198if [ "${clear_tmp_enable}" = "YES" ]; then
199 echo clearing /tmp
200
201 # prune quickly with one rm, then use find to clean up /tmp/[lq]*
202 # (not needed with mfs /tmp, but doesn't hurt there...)
203 (cd /tmp && rm -rf [a-km-pr-zA-Z]* &&
204 find -d . ! -name . ! -name lost+found ! -name quota.user \
205 ! -name quota.group -exec rm -rf -- {} \;)
206
207fi
208
209# Remove X lock files, since they will prevent you from restarting X11
210# after a system crash.
211rm -f /tmp/.X*-lock /tmp/.X11-unix/*
212
213# snapshot any kernel -c changes back to disk here <someday>
214# this has changed with ELF and /kernel.config.
215
216echo -n 'additional daemons:'
217# start system logging and name service (named needs to start before syslogd
218# if you don't have a /etc/resolv.conf)
219#
220if [ "${syslogd_enable}" = "YES" ]; then
221 # Transitional symlink (for the next couple of years :) until all
222 # binaries had a chance to move towards /var/run/log.
223 if [ ! -h /dev/log ] ; then
224 # might complain for r/o root f/s
225 ln -sf /var/run/log /dev/log
226 fi
227
228 rm -f /var/run/log
229 echo -n ' syslogd'; syslogd ${syslogd_flags}
230fi
231echo '.'
232
233# enable dumpdev so that savecore can see it
234# /var/crash should be a directory or a symbolic link
235# to the crash directory if core dumps are to be saved.
236if [ "${dumpdev}" != "NO" -a -e ${dumpdev} -a -d /var/crash ]; then
237 dumpon ${dumpdev}
238 echo -n checking for core dump...
239 savecore /var/crash
240fi
241
242if [ -n "${network_pass1_done}" ]; then
243 network_pass2
244fi
245
246# Enable/Check the quotas (must be after ypbind if using NIS)
247if [ "${enable_quotas}" = "YES" ]; then
248
249 # Only check quotas if they have been previously enabled, and requested
250 if [ "${check_quotas}" = "YES" ]; then
251 echo -n 'checking quotas:'
252 quotacheck -a
253 echo ' done.'
254 fi
255
256 echo -n 'enabling quotas:'
257 quotaon -a
258 echo ' done.'
259fi
260
261if [ -n "${network_pass2_done}" ]; then
262 network_pass3
263fi
264
265
266# build ps databases
267kvm_mkdb
268dev_mkdb
269
270# check the password temp/lock file
271if [ -f /etc/ptmp ]
272then
273 logger -s -p auth.err \
274 "password file may be incorrect -- /etc/ptmp exists"
275fi
276
277if [ "${accounting_enable}" = "YES" -a -d /var/account ]; then
278 echo 'turning on accounting'
279 if [ ! -e /var/account/acct ]; then
280 touch /var/account/acct
281 fi
282 accton /var/account/acct
283fi
284
285# Make shared lib searching a little faster. Leave /usr/lib first if you
286# add your own entries or you may come to grief.
287if [ -x /sbin/ldconfig ]; then
288 if [ "`/usr/bin/objformat`" = "elf" ]; then
289 _LDC=/usr/lib
290 for i in ${ldconfig_paths}; do
291 if test -d ${i}; then
292 _LDC="${_LDC} ${i}"
293 fi
294 done
295 echo 'setting ELF ldconfig path:' ${_LDC}
296 ldconfig -elf ${_LDC}
297 fi
298
299 # Legacy aout support for i386 only
300 if [ "`sysctl -n hw.machine`" = "i386" ]; then
301 # Default the a.out ldconfig path.
302 : ${ldconfig_paths_aout=${ldconfig_paths}}
303 _LDC=/usr/lib/aout
304 for i in ${ldconfig_paths_aout}; do
305 if test -d ${i}; then
306 _LDC="${_LDC} ${i}"
307 fi
308 done
309 echo 'setting a.out ldconfig path:' ${_LDC}
310 ldconfig -aout ${_LDC}
311 fi
312fi
313
314# Now start up miscellaneous daemons that don't belong anywhere else
315#
316echo -n starting standard daemons:
317if [ "${inetd_enable}" != "NO" ]; then
318 echo -n ' inetd'; inetd ${inetd_flags}
319fi
320
321if [ "${cron_enable}" != "NO" ]; then
322 echo -n ' cron'; cron
323fi
324
325if [ "${lpd_enable}" = "YES" ]; then
326 echo -n ' printer'; ${lpd_program} ${lpd_flags}
327fi
328
329if [ "${sendmail_enable}" = "YES" -a -r /etc/sendmail.cf ]; then
330 echo -n ' sendmail'; /usr/sbin/sendmail ${sendmail_flags}
331fi
332
333if [ "${usbd_enable}" = "YES" ]; then
334 echo -n ' usbd'; /usr/sbin/usbd ${usbd_flags}
335fi
336
337echo '.'
338
339# configure implementation specific stuff
340arch=`uname -m`
341if [ -f /etc/rc.${arch} ]; then
342 . /etc/rc.${arch}
343fi
344
345# Recover vi editor files.
346find /var/tmp/vi.recover ! -type f -a ! -type d -delete
347vibackup=`echo /var/tmp/vi.recover/vi.*`
348if [ "${vibackup}" != '/var/tmp/vi.recover/vi.*' ]; then
349 echo 'Recovering vi editor sessions'
350 for i in ${vibackup}; do
351 # Only test files that are readable.
352 if test ! -r ${i}; then
353 continue
354 fi
355
356 # Unmodified nvi editor backup files either have the
357 # execute bit set or are zero length. Delete them.
358 if test -x ${i} -o ! -s ${i}; then
359 rm -f ${i}
360 fi
361 done
362
363 # It is possible to get incomplete recovery files, if the editor
364 # crashes at the right time.
365 virecovery=`echo /var/tmp/vi.recover/recover.*`
366 if [ "${virecovery}" != "/var/tmp/vi.recover/recover.*" ]; then
367 for i in ${virecovery}; do
368 # Only test files that are readable.
369 if test ! -r ${i}; then
370 continue
371 fi
372
373 # Delete any recovery files that are zero length,
374 # corrupted, or that have no corresponding backup file.
375 # Else send mail to the user.
376 recfile=`awk '/^X-vi-recover-path:/{print $2}' < ${i}`
377 if test -n "${recfile}" -a -s "${recfile}"; then
378 sendmail -t < ${i}
379 else
380 rm -f ${i}
381 fi
382 done
383 fi
384fi
385
386# make a bounds file for msgs(1) if there isn't one already
387if [ -d /var/msgs -a ! -f /var/msgs/bounds ]; then
388 echo 0 > /var/msgs/bounds
389fi
390
391# for each valid dir in $local_startup, search for init scripts matching *.sh
392if [ "${local_startup}" != "NO" ]; then
393 echo -n 'Local package initialization:'
394 for dir in ${local_startup}; do
395 [ -d ${dir} ] && for script in ${dir}/*.sh; do
396 [ -x ${script} ] && \
397 (set -T ; trap 'exit 1' 2 ; ${script} start)
398 done
399 done
400 echo .
401fi
402
403if [ "${update_motd}" != "NO" ]; then
404 T=`mktemp /tmp/_motd.XXXXXX`
405 if [ $? -eq 0 ]; then
406 uname -v | sed -e 's,^\([^#]*\) #\(.* [1-2][0-9][0-9][0-9]\).*/\([^\]*\) $,\1 (\3) #\2,' > ${T}
407 awk '{if (NR == 1) {if ($1 == "FreeBSD") {next} else {print "\n"$0}} else {print}}' < /etc/motd >> ${T}
408 cmp -s ${T} /etc/motd || {
409 cp ${T} /etc/motd
410 chmod 644 /etc/motd
411 }
412 rm -f ${T}
413 fi
414fi
415
416# Run rc.devfs if present to customize devfs
417[ -f /etc/rc.devfs ] && sh /etc/rc.devfs
418
419# Do traditional (but rather obsolete) rc.local file if it exists. If you
420# use this file and want to make it programmatic, source /etc/defaults/rc.conf
421# in /etc/rc.local and add your custom variables to /etc/rc.conf, as
422# shown below. Please do not put local extensions into /etc/rc itself.
423# Use /etc/rc.local
424#
425# ---- rc.local ----
426# if [ -f /etc/defaults/rc.conf ]; then
427# . /etc/defaults/rc.conf
428# fi
429#
430# ... additional startup conditionals ...
431# ---- rc.local ----
432#
433if [ -f /etc/rc.local ]; then
434 echo -n 'starting local daemons:'
435 sh /etc/rc.local
436 echo '.'
437fi
438
439# Raise kernel security level. This should be done only after `fsck' has
440# repaired local file systems if you want the securelevel to be greater than 1.
441if [ "${kern_securelevel_enable}" = "YES" -a "${kern_securelevel}" -ge 0 ];
442then
443 echo 'Raising kernel security level'
444 sysctl -w kern.securelevel=${kern_securelevel}
445fi
446
447date
448exit 0